unit Unit0029;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Image1: TImage;
    Edit1: TEdit;
    Button1: TButton;
    Label1: TLabel;
    LabelA2: TLabel;
    LabelA1: TLabel;
    LabelA3: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Edit2: TEdit;
    Label4: TLabel;
    Edit3: TEdit;
    Button2: TButton;
    GroupBox1: TGroupBox;
    Label5: TLabel;
    Edit4: TEdit;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    ScrollBar1: TScrollBar;
    ScrollBar2: TScrollBar;
    Button8: TButton;
    Button9: TButton;
    Button10: TButton;
    Button11: TButton;
    Button12: TButton;
    LabelA4: TLabel;
    Button13: TButton;
    Button14: TButton;
    Button15: TButton;
    procedure FormShow(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ScrollBar1Change(Sender: TObject);
    procedure ScrollBar2Change(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure Button10Click(Sender: TObject);
    procedure Button11Click(Sender: TObject);
    procedure Button12Click(Sender: TObject);
    procedure Button13Click(Sender: TObject);
    procedure Button14Click(Sender: TObject);
    procedure Button15Click(Sender: TObject);
    procedure Image1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Image1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Private 錾 }
    ix,iy : Integer ;         // ʃhbgTCY
    px,py,mm_dot : Double ;   // pTCYAmm-dot
    x1,y1,x2,y2 : Double ;    // r[GA
    mm_dot_max : Double ;     // (MAX)mm-dot
    Fmode : Integer ;         // @\[h
    FBx,FBy : Double ;        // @\s̍ۂɋLwW
    RBflag : Boolean ;        // o[oh\tO True:\ False:\
    RBx1,RBy1 : Integer ;     // o[ohJn_
    RBx2,RBy2 : Integer ;     // o[ohI_
    DRGx1,DRGy1 : Integer ;   // hbOJn_
    DRGx2,DRGy2 : Integer ;   // hbOI_
    DRGmode : Integer ;       // hbO[h 0:ړ 1:g(SHIFT) 2:k(CTRL)
    DRGflag : Boolean ;       // hbOǂ̃tO
    DRGRBflag : Boolean ;     // hbÕo[oh\tO
    procedure GCLS ;    // ʃNA
    procedure GDRAW ;   // ʍ}
    procedure GREDRAW ; // ʍč}
    procedure MouseClick(X,Y:Integer);
    procedure GRBLINE(rx1,ry1,rx2,ry2:Integer); // o[oh`
    procedure GRBBOX(rx1,ry1,rx2,ry2:Integer);  // o[oh``
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

// 
procedure TForm1.FormShow(Sender: TObject);
begin
   Fmode := 0 ;
   RBflag := False ;
   DRGflag := False ;
   DRGRBflag := False ;
   Button1Click(Sender);
end;

// }
procedure TForm1.Button1Click(Sender: TObject);
var
   p1,p2 : Double ;
begin
   GCLS ;   // ʂNA
   px := StrToFloat(Edit1.Text);
   py := StrToFloat(Edit2.Text);
   p1 := ix / px ;
   p2 := iy / py ;
   if (p1 < p2) then mm_dot := p1 else mm_dot := p2 ;
   Edit3.Text := FloatToStr(mm_dot);
   mm_dot_max := mm_dot ;
   x1 := - ix / 2.0 / mm_dot ;
   y1 := - iy / 2.0 / mm_dot ;
   x2 :=   ix / 2.0 / mm_dot ;
   y2 :=   iy / 2.0 / mm_dot ;
   LabelA1.Caption := '( '+FloatToStr(x1)+' , '+FloatToStr(y1)+' )';
   LabelA2.Caption := '( '+FloatToStr(x2)+' , '+FloatToStr(y2)+' )';
   GDRAW ;  // ʂ}
end;

// wmm_dotŕ\
procedure TForm1.Button2Click(Sender: TObject);
begin
   mm_dot := StrToFloat(Edit3.Text);
   x1 := - ix / 2.0 / mm_dot ;
   y1 := - iy / 2.0 / mm_dot ;
   x2 :=   ix / 2.0 / mm_dot ;
   y2 :=   iy / 2.0 / mm_dot ;
   GREDRAW ;  // ʍč}
end;

// ʂNA
procedure TForm1.GCLS ;
begin
   Image1.Picture := nil ;
   with Image1.Canvas do begin
      ix := Image1.Width ;
      iy := Image1.Height ;
      // ʂ
      with Pen do begin
         Mode  := pmCopy ;
         Color := clWhite;
         Style := psSolid;
         Width := 1;
      end;
      with Brush do begin
         Color := clWhite;
         Style := bsSolid;
      end;
      Rectangle(0,0,ix,iy);
   end;
end;

// ʂ}
procedure TForm1.GDRAW ;
var
   ax1,ay1,ax2,ay2 : Integer ;
begin
   with Image1.Canvas do begin
      // pg
      ax1 := Round( ( -px/2 - x1 ) * mm_dot );
      ay1 := Round(-( -py/2 - y2 ) * mm_dot );
      ax2 := Round( (  px/2 - x1 ) * mm_dot );
      ay2 := Round(-(  py/2 - y2 ) * mm_dot );
      Pen.Mode  := pmCopy ;
      Pen.Color := clBlue ;
      Brush.Style := bsClear ;
      Rectangle(ax1,ay1,ax2,ay2);
      // _
      ax1 := Round( ( 0.0 - x1 ) * mm_dot );
      ay1 := Round(-( 0.0 - y2 ) * mm_dot );
      Pen.Color := clRed ;
      MoveTo(ax1-5,ay1);   LineTo(ax1+6,ay1);
      MoveTo(ax1,ay1-5);   LineTo(ax1,ay1+6);
      // lp`
      ax1 := Round( ( -20 - x1 ) * mm_dot );
      ay1 := Round(-( -10 - y2 ) * mm_dot );
      ax2 := Round( (  20 - x1 ) * mm_dot );
      ay2 := Round(-(  10 - y2 ) * mm_dot );
      Pen.Color := clBlack ;
      Brush.Style := bsClear ;
      Rectangle(ax1,ay1,ax2,ay2);
   end;
end;

// ʂč}
procedure TForm1.GREDRAW ;
begin
   GCLS ;   // ʂNA
   LabelA1.Caption := '( '+FloatToStr(x1)+' , '+FloatToStr(y1)+' )';
   LabelA2.Caption := '( '+FloatToStr(x2)+' , '+FloatToStr(y2)+' )';
   GDRAW ;  // ʂ}
end;

// []ĉʈړ
procedure TForm1.Button3Click(Sender: TObject);
var
   p : Double ;
begin
   p := StrToFloat(Edit4.Text);
   y1 := y1 + p ;
   y2 := y2 + p ;
   GREDRAW ;  // ʍč}
end;

// []ĉʈړ
procedure TForm1.Button4Click(Sender: TObject);
var
   p : Double ;
begin
   p := StrToFloat(Edit4.Text);
   y1 := y1 - p ;
   y2 := y2 - p ;
   GREDRAW ;  // ʍč}
end;

// []ĉʈړ
procedure TForm1.Button5Click(Sender: TObject);
var
   p : Double ;
begin
   p := StrToFloat(Edit4.Text);
   x1 := x1 - p ;
   x2 := x2 - p ;
   GREDRAW ;  // ʍč}
end;

// []ĉʈړ
procedure TForm1.Button6Click(Sender: TObject);
var
   p : Double ;
begin
   p := StrToFloat(Edit4.Text);
   x1 := x1 + p ;
   x2 := x2 + p ;
   GREDRAW ;  // ʍč}
end;

// []ĉʈړ
procedure TForm1.Button7Click(Sender: TObject);
begin
   x1 := - ix / 2.0 / mm_dot ;
   y1 := - iy / 2.0 / mm_dot ;
   x2 :=   ix / 2.0 / mm_dot ;
   y2 :=   iy / 2.0 / mm_dot ;
   GREDRAW ;  // ʍč}
end;

// L[ĉʈړ
procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
   if (Key = VK_UP) then begin
      Button3Click(Sender);
      Key := 0 ;
   end
   else if (Key = VK_DOWN) then begin
      Button4Click(Sender);
      Key := 0 ;
   end
   else if (Key = VK_LEFT) then begin
      Button5Click(Sender);
      Key := 0 ;
   end
   else if (Key = VK_RIGHT) then begin
      Button6Click(Sender);
      Key := 0 ;
   end
   else if (Key = VK_HOME) then begin
      Button7Click(Sender);
      Key := 0 ;
   end;
end;

// XN[o[ňړ
procedure TForm1.ScrollBar1Change(Sender: TObject);
var
   p : double ;
begin
   p := px/2.0 * ScrollBar1.Position/100.0 ;
   x1 := - ix / 2.0 / mm_dot + p ;
   x2 :=   ix / 2.0 / mm_dot + p ;
   GREDRAW ;  // ʍč}
end;

// XN[o[ňړ
procedure TForm1.ScrollBar2Change(Sender: TObject);
var
   p : double ;
begin
   p := - py/2.0 * ScrollBar2.Position/100.0 ;
   y1 := - iy / 2.0 / mm_dot + p ;
   y2 :=   iy / 2.0 / mm_dot + p ;
   GREDRAW ;  // ʍč}
end;

// Q{Ɋg
procedure TForm1.Button8Click(Sender: TObject);
var
   cx,cy : double ;
   dx,dy : double ;
begin
   cx := (x1+x2)/2.0 ;  // ݂̒̍W
   cy := (y1+y2)/2.0 ;
   dx := Abs(x2-x1) ;   // ݂̃r[̑傫
   dy := Abs(y2-y1) ;   // Abs͕KvǈꉞĂ
   mm_dot := mm_dot * 2.0 ;
   Edit3.Text := FloatToStr(mm_dot);
   x1 := cx - dx/4.0;   // g偁r[1/2ɏȂ
   y1 := cy - dy/4.0;
   x2 := cx + dx/4.0;
   y2 := cy + dy/4.0;
   GREDRAW ;  // ʍč}
end;

// 1/2{ɏk
procedure TForm1.Button9Click(Sender: TObject);
var
   cx,cy : double ;
   dx,dy : double ;
begin
   cx := (x1+x2)/2.0 ;  // ݂̒̍W
   cy := (y1+y2)/2.0 ;
   dx := Abs(x2-x1) ;   // ݂̃r[̑傫
   dy := Abs(y2-y1) ;   // Abs͕KvǈꉞĂ
   mm_dot := mm_dot * 0.5 ;
   Edit3.Text := FloatToStr(mm_dot);
   x1 := cx - dx;       // kr[͂Q{ɑ傫Ȃ
   y1 := cy - dy;
   x2 := cx + dx;
   y2 := cy + dy;
   GREDRAW ;  // ʍč}
end;

// }EXŉʈړ
procedure TForm1.Button10Click(Sender: TObject);
begin
   Fmode := 1 ;   // @\[hZbg
   LabelA4.Caption := '}EXŉʈړ';
end;

// }EXłQ{g
procedure TForm1.Button11Click(Sender: TObject);
begin
   Fmode := 2 ;   // @\[hZbg
   LabelA4.Caption := '}EXłQ{g';
end;

// }EX1/2{k
procedure TForm1.Button12Click(Sender: TObject);
begin
   Fmode := 3 ;   // @\[hZbg
   LabelA4.Caption := '}EX1/2{k';
end;

// Q_wʈړ
procedure TForm1.Button13Click(Sender: TObject);
begin
   Fmode := 10 ;  // @\[hZbg
   LabelA4.Caption := 'ʈړEJn_w';
end;

// Q_wʊg
procedure TForm1.Button14Click(Sender: TObject);
begin
   Fmode := 20 ;  // @\[hZbg
   LabelA4.Caption := 'ʊgEJn_w';
end;

// Q_wʏk
procedure TForm1.Button15Click(Sender: TObject);
begin
   Fmode := 30 ;  // @\[hZbg
   LabelA4.Caption := 'ʏkEJn_w';
end;

// }EX{^̏
procedure TForm1.Image1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
   if ssLeft in Shift then begin    // NbN
      DRGflag := False ;
      MouseClick(X,Y);
   end
   else if ssRight in Shift then begin    // ENbN
      DRGflag := True ;
      DRGx1 := X ;
      DRGy1 := Y ;
      DRGRBflag := False ;
   end;
end;

// }EX𓮂
procedure TForm1.Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var
   tx,ty : double ;
begin
   tx := x1 + X / mm_dot ;
   ty := y2 - Y / mm_dot ;
   LabelA3.Caption := '( '+FloatToStr(tx)+' , '+FloatToStr(ty)+' )';
   //
   if (DRGflag) then begin // EhbO
      if (DRGRBflag) then begin
         GRBBOX(DRGx1,DRGy1,DRGx2,DRGy2);
      end;
      GRBBOX(DRGx1,DRGy1,X,Y);
      DRGRBflag := True ;
      DRGx2 := X ;
      DRGy2 := Y ;
   end
   else begin  // }EXړ
      Case (Fmode) of
      11:begin // Q_wʈړEI_
            if (RBflag) then begin  // ȑÕo[oh
               GRBLINE(RBx1,RBy1,RBx2,RBy2);
            end;
            GRBLINE(RBx1,RBy1,X,Y); // Vo[oh`
            RBflag := True ;
            RBx2 := X ;
            RBy2 := Y ;
         end;
      21,31:
         begin // Q_wʊgkEI_
            if (RBflag) then begin  // ȑÕo[oh
               GRBBOX(RBx1,RBy1,RBx2,RBy2);
            end;
            GRBBOX(RBx1,RBy1,X,Y); // Vo[oh`
            RBflag := True ;
            RBx2 := X ;
            RBy2 := Y ;
         end;
      end;
   end;
end;

// }EX{^𗣂̏
procedure TForm1.Image1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
   xx1,yy1,xx2,yy2 : double ;
   cx,cy : double ;
   dx,dy : double ;
   bx,by : double ;
   p1,p2 : Double ;
begin
   if (DRGflag) then begin
      // hbO
      DRGflag := False ;
      if (DRGRBflag) then begin
         GRBBOX(DRGx1,DRGy1,DRGx2,DRGy2);
      end;
      if (Abs(DRGx1-X) <= 5)and(Abs(DRGy1-Y) <= 5) then
         DRGmode := 0
      else begin
         if (DRGx1 <= X) then
            DRGmode := 1
         else
            DRGmode := 2;
      end;
      xx1 := x1 + DRGx1 / mm_dot ;
      yy1 := y2 - DRGy1 / mm_dot ;
      xx2 := x1 + X / mm_dot ;
      yy2 := y2 - Y / mm_dot ;
      dx := Abs(x2-x1) ;   // ݂̃r[̑傫
      dy := Abs(y2-y1) ;   // Abs͕KvǈꉞĂ
      bx := Abs(xx1-xx2);  // `̑傫
      by := Abs(yy1-yy2);
      cx := (xx1+xx2)/2.0; // `̒̍W
      cy := (yy1+yy2)/2.0;
      Case (DRGmode) of
      0: begin    // ړ
            cx := (x1+x2)/2.0 ;  // ݂̒̍W
            cy := (y1+y2)/2.0 ;
            dx := xx2 - cx ;      // ړ
            dy := yy2 - cy ;
            x1 := x1 + dx ;      // ړvZ
            y1 := y1 + dy ;
            x2 := x2 + dx ;
            y2 := y2 + dy ;
            GREDRAW ;   // ʍč}
         end;
      1: begin    // g
            if (bx < 0.000001) then bx:=0.000001;
            if (by < 0.000001) then by:=0.000001;
            p1 := dx / bx ;         // ݂̉ʂɑ΂ĉ{H
            p2 := dy / by ;
            if (p1 < p2) then mm_dot := mm_dot*p1 else mm_dot := mm_dot*p2 ;
            Edit3.Text := FloatToStr(mm_dot);
            x1 := cx - ix / 2.0 / mm_dot ;   // r[GAvZ
            y1 := cy - iy / 2.0 / mm_dot ;
            x2 := cx + ix / 2.0 / mm_dot ;
            y2 := cy + iy / 2.0 / mm_dot ;
            GREDRAW ;   // ʍč}
         end;
      2: begin    // k
            p1 := bx / dx ;         // ݂̉ʂ牽{H
            p2 := by / dy ;
            if (p1 > p2) then mm_dot := mm_dot*p1 else mm_dot := mm_dot*p2 ;
            if (mm_dot < mm_dot_max) then mm_dot := mm_dot_max ;
            Edit3.Text := FloatToStr(mm_dot);
            x1 := cx - ix / 2.0 / mm_dot ;   // r[GAvZ
            y1 := cy - iy / 2.0 / mm_dot ;
            x2 := cx + ix / 2.0 / mm_dot ;
            y2 := cy + iy / 2.0 / mm_dot ;
            GREDRAW ;   // ʍč}
         end;
      end;
   end
end;

// }EXNbN
procedure TForm1.MouseClick(X,Y:Integer);
var
   cx,cy : double ;
   tx,ty : double ;
   dx,dy : double ;
   bx,by : double ;
   p1,p2 : Double ;
begin
   cx := (x1+x2)/2.0 ;  // ݂̒̍W
   cy := (y1+y2)/2.0 ;
   dx := Abs(x2-x1) ;   // ݂̃r[̑傫
   dy := Abs(y2-y1) ;   // Abs͕KvǈꉞĂ
   tx := x1 + X / mm_dot ; // NbNW
   ty := y2 - Y / mm_dot ;
   Case (Fmode) of
   1: begin // ʈړ
         dx := tx - cx ;      // ړ
         dy := ty - cy ;
         x1 := x1 + dx ;      // ړvZ
         y1 := y1 + dy ;
         x2 := x2 + dx ;
         y2 := y2 + dy ;
         GREDRAW ;   // ʍč}
      end;
   2: begin // Q{g
         mm_dot := mm_dot * 2.0 ;
         Edit3.Text := FloatToStr(mm_dot);
         x1 := tx - dx/4.0;   // g偁r[1/2ɏȂ
         y1 := ty - dy/4.0;
         x2 := tx + dx/4.0;
         y2 := ty + dy/4.0;
         GREDRAW ;  // ʍč}
      end;
   3: begin // 1/2{k
         mm_dot := mm_dot * 0.5 ;
         Edit3.Text := FloatToStr(mm_dot);
         x1 := tx - dx;       // kr[1/2ɏȂ
         y1 := ty - dy;
         x2 := tx + dx;
         y2 := ty + dy;
         GREDRAW ;  // ʍč}
      end;
   10:begin // Q_wʈړEJn_
         FBx := tx ;    // NbNWJn_ƂċL
         FBy := ty ;
         Fmode := 11 ;  // @\[hZbg
         LabelA4.Caption := 'ʈړEI_w';
         RBflag := False ;
         RBx1 := X ;
         RBy1 := Y ;
      end;
   11:begin // Q_wʈړEI_
         if (RBflag) then begin  // ܂o[ohĂ
            GRBLINE(RBx1,RBy1,RBx2,RBy2);
            RBflag := False ;
         end;
         dx := FBx - tx ;  // ړ
         dy := FBy - ty ;
         x1 := x1 + dx ;   // ړvZ
         y1 := y1 + dy ;
         x2 := x2 + dx ;
         y2 := y2 + dy ;
         GREDRAW ;   // ʍč}
         Fmode := 10 ;  // @\[hZbg
         LabelA4.Caption := 'ʈړEJn_w';
      end;
   20:begin // Q_wʊgEJn_
         FBx := tx ;    // NbNWJn_ƂċL
         FBy := ty ;
         Fmode := 21 ;  // @\[hZbg
         LabelA4.Caption := 'ʊgEI_w';
         RBflag := False ;
         RBx1 := X ;
         RBy1 := Y ;
      end;
   21:begin // Q_wʊgEI_
         if (RBflag) then begin  // ܂o[ohĂ
            GRBBOX(RBx1,RBy1,RBx2,RBy2);
            RBflag := False ;
         end;
         bx := Abs(FBx - tx) ;   // `̑傫
         by := Abs(FBy - ty) ;
         if (bx < 0.000001) then bx:=0.000001;
         if (by < 0.000001) then by:=0.000001;
         cx := (FBx+tx)/2.0 ;    // `̒̍W
         cy := (FBy+ty)/2.0 ;
         p1 := dx / bx ;         // ݂̉ʂɑ΂ĉ{H
         p2 := dy / by ;
         if (p1 < p2) then mm_dot := mm_dot*p1 else mm_dot := mm_dot*p2 ;
         Edit3.Text := FloatToStr(mm_dot);
         x1 := cx - ix / 2.0 / mm_dot ;   // r[GAvZ
         y1 := cy - iy / 2.0 / mm_dot ;
         x2 := cx + ix / 2.0 / mm_dot ;
         y2 := cy + iy / 2.0 / mm_dot ;
         GREDRAW ;   // ʍč}
         Fmode := 20 ;  // @\[hZbg
         LabelA4.Caption := 'ʊgEJn_w';
      end;
   30:begin // Q_wʏkEJn_
         FBx := tx ;    // NbNWJn_ƂċL
         FBy := ty ;
         Fmode := 31 ;  // @\[hZbg
         LabelA4.Caption := 'ʏkEI_w';
         RBflag := False ;
         RBx1 := X ;
         RBy1 := Y ;
      end;
   31:begin // Q_wʏkEI_
         if (RBflag) then begin  // ܂o[ohĂ
            GRBBOX(RBx1,RBy1,RBx2,RBy2);
            RBflag := False ;
         end;
         bx := Abs(FBx - tx) ;   // `̑傫
         by := Abs(FBy - ty) ;
         cx := (FBx+tx)/2.0 ;    // `̒̍W
         cy := (FBy+ty)/2.0 ;
         p1 := bx / dx ;         // ݂̉ʂ牽{H
         p2 := by / dy ;
         if (p1 > p2) then mm_dot := mm_dot*p1 else mm_dot := mm_dot*p2 ;
         Edit3.Text := FloatToStr(mm_dot);
         x1 := cx - ix / 2.0 / mm_dot ;   // r[GAvZ
         y1 := cy - iy / 2.0 / mm_dot ;
         x2 := cx + ix / 2.0 / mm_dot ;
         y2 := cy + iy / 2.0 / mm_dot ;
         GREDRAW ;   // ʍč}
         Fmode := 30 ;  // @\[hZbg
         LabelA4.Caption := 'ʏkEJn_w';
      end;
   end;
end;

// o[oh`
procedure TForm1.GRBLINE(rx1,ry1,rx2,ry2:Integer);
begin
   with Image1.Canvas do begin
      Pen.Mode := pmXor ;
      Pen.Color := clAqua ;
      Pen.Width := 0 ;
      Pen.Style := psSolid ;
      MoveTo(rx1,ry1);
      LineTo(rx2,ry2);
   end;
end;

// o[oh``
procedure TForm1.GRBBOX(rx1,ry1,rx2,ry2:Integer);
begin
   with Image1.Canvas do begin
      Pen.Mode := pmXor ;
      Pen.Color := clAqua ;
      Pen.Width := 0 ;
      Pen.Style := psSolid ;
      Brush.Style := bsClear ;
      Rectangle(rx1,ry1,rx2,ry2);
   end;
end;

end.
